import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Budi here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Budi extends Mover
{
     /**
     * Act - do whatever the budi wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int counterFow=0;
    private int counterSide=0;
    private int delay=0;
    private int verticalSpeed;
    private int jumpDistance=15;
    private boolean isJumping;
    private int boyBottom;
    private int acceleration=2;
    private boolean isKeyPressed;
    private int budiBottomCenter;
    private boolean facingRight;
    public static boolean isDead;
    private int vSpeed=0;
//    private int acceleration=2;
    private boolean jumping;
    private int jumpStrength=5;
    
    private final GreenfootImage walkR1=new GreenfootImage("Budi1.png");
    private final GreenfootImage walkR2=new GreenfootImage("Budi2.png");
    private final GreenfootImage walkR3=new GreenfootImage("Budi3.png");
    
    private final GreenfootImage walkL1=new GreenfootImage(walkR1);
    private final GreenfootImage walkL2=new GreenfootImage(walkR2);
    private final GreenfootImage walkL3=new GreenfootImage(walkR3);
    
    private final GreenfootImage jumpR=new GreenfootImage("BudiJumps.png");
    private final GreenfootImage jumpL=new GreenfootImage(jumpR);
    
    public Budi(){
        this.speed=1;
        facingRight=true;
        animationCounter = 0;
        isJumping = false;
        isDead = false;
        
        setImage(walkR2);
        walkL1.mirrorHorizontally();
        walkL2.mirrorHorizontally();
        walkL3.mirrorHorizontally();
        jumpL.mirrorHorizontally();
        
        budiBottomCenter=getImage().getHeight()/2;
    }
    
    public void act() 
    {
     //int delay=10;
     //int count;
        if(isDead==false){
            checkKeys();
            checkFall();
          //  if(getWorld()!=null&&!checkGround()){
            //    fall();
            //}else{
              //  isJumping=false;
        }else if(isDead==true){
            isDead=true;
            playDead();
        }
    }
    
    private void playDead(){
        //MATI
        Greenfoot.delay(20);
        getWorld().addObject(new BudiLose(),getX(), getY());
        getWorld().removeObject(this);
    }
    
    private void boundary(){
        Levels L=(Levels)getWorld();
        if(getX()<=21){
            setLocation(21,getY());
        }else if(getX()>=900){
            L.setupLevel(L.level+1);
        }else if(L.level==4&&getX()>800){
            setLocation(800,getY());
        }
    }
    
    public void checkKeys(){
        isKeyPressed=false;
        if(Greenfoot.isKeyDown("right") && Greenfoot.isKeyDown("left")){
            stopWalking();
        }else if(Greenfoot.isKeyDown("right")){
            animationCounter ++;
            walkRight();
            isKeyPressed=true;
            facingRight=true;
        }else if(Greenfoot.isKeyDown("left")){
            animationCounter++;
            walkLeft();
            isKeyPressed=true;
            facingRight=false;
        }
        
        if(Greenfoot.isKeyDown("up")&&isJumping==false){
            isKeyPressed=true;
            jump();
        }
        
        if(!isKeyPressed){
            stopWalking();
        }
    }
    
    private void walkRight(){
        moveRight();
        if(animationCounter<4){
            setImage(walkR2);
        }else if(animationCounter<8){
            setImage(walkR1);
        }else if(animationCounter<12){
            setImage(walkR2);
        }else if(animationCounter<16){
            setImage(walkR3);
        }else if(animationCounter==16){
            animationCounter=0;
        }
        return;
    }
    
    private void walkLeft(){
        moveLeft();
        if(animationCounter<4){
            setImage(walkL2);
        }else if(animationCounter<8){
            setImage(walkL1);
        }else if(animationCounter<12){
            setImage(walkL2);
        }else if(animationCounter<16){
            setImage(walkL3);
        }else if(animationCounter==16){
            animationCounter=0;
        }
        return;
    }
    
    private void stopWalking(){
        if(facingRight){
//            setImage(walkR2);
            animationCounter++;
            if(animationCounter<4){//Semakin banyak nilainya semakin lambat
                setImage(walkR2);
            }else if(animationCounter<8){
                setImage(walkR1);
            }else if(animationCounter<12){
                setImage(walkR2);
            }else if(animationCounter<16){
                setImage(walkR3);
            }else if(animationCounter==16){
                animationCounter=0;
            }
    }else{
//        setImage(walkL2);
            animationCounter++;
            if(animationCounter<4){
                setImage(walkL2);
            }else if(animationCounter<8){
                setImage(walkL1);
            }else if(animationCounter<12){
                setImage(walkL2);
            }else if(animationCounter<16){
                setImage(walkL3);
            }else if(animationCounter==16){
                animationCounter=0;
            }    
    }
            
    }
    
    public boolean atWorldEdge(){
    if(getX()<10 || getX()>getWorld().getWidth()-10)
    return true;
    if(getY()<10 || getY()>getWorld().getHeight()-10)
    return true;
    else
    return false;
    }
    
//    private void fall()
  //  {
    //    setLocation ( getX(), getY() + verticalSpeed);
      //  verticalSpeed = verticalSpeed + acceleration;
        //isJumping = true;
       // checkGround(); // See if we are touching the ground to reset vert speed to 0

        //if (facingRight)
       // {
         //   setImage(jumpR);
        //}
        //else
        //{
          //  setImage(jumpL);
        //}

        //if (getY() >= getWorld().getHeight() + 100) // check if fall out of world
        //{
          //  isDead = true;
        //}
    //}
    public void fall(){
        setLocation(getX(),getY()+vSpeed);
        if(vSpeed<=9){
            vSpeed = vSpeed+acceleration;
        }
        jumping=true;
    }
    
    public boolean onGround(){
        int spriteHeight=getImage().getHeight();
        int yDistance=(int) (spriteHeight/2+5);
        
        Actor ground=getOneObjectAtOffset(0, getImage().getHeight()/2, Ground.class);
        if(ground==null){
            jumping=true;
            return false;
        } else{
            moveToGround(ground);
            return true;
        }
    }
    
    public void moveToGround(Actor ground){
        int groundHeight=ground.getImage().getHeight();
        int newY=ground.getY()-(groundHeight+getImage().getHeight())/2;
        
        setLocation(getX(),newY);
        jumping=false;
    }
    
    public void checkFall(){
        if(onGround()){
            vSpeed=0;
        } else{
            fall();
        }
    }
    
    public void jump(){
        vSpeed=vSpeed-jumpStrength;
        jumping=true;
        fall();
        setImage(jumpR);
    }
}
